/// @cond EO_CXX_EO_IMPL

inline ::elm::widget_item elm::menu_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item elm::menu_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline unsigned int elm::menu_item::index_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_index_get());
   return _tmp_ret;
}

inline void elm::menu_item::subitems_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_subitems_clear());
}

inline ::efl::eina::crange_list< ::elm::widget_item > elm::menu_item::subitems_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_subitems_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool elm::menu_item::is_separator() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_is_separator());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object elm::menu_item::object_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_object_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::string_view elm::menu_item::icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::menu_item::icon_name_set(::efl::eina::string_view icon_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_icon_name_set(::efl::eolian::to_c(icon_)));
}

inline bool elm::menu_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::menu_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline ::elm::widget_item eo_cxx::elm::menu_item::prev_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_prev_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::elm::widget_item eo_cxx::elm::menu_item::next_get() const
{
   Elm_Widget_Item * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_next_get());
   return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
}

inline unsigned int eo_cxx::elm::menu_item::index_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_index_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::menu_item::subitems_clear() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_subitems_clear());
}

inline ::efl::eina::crange_list< ::elm::widget_item > eo_cxx::elm::menu_item::subitems_get() const
{
   const Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_subitems_get());
   return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}

inline bool eo_cxx::elm::menu_item::is_separator() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_is_separator());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::evas::object eo_cxx::elm::menu_item::object_get() const
{
   Evas_Object * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_object_get());
   return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::string_view eo_cxx::elm::menu_item::icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::menu_item::icon_name_set(::efl::eina::string_view icon_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_icon_name_set(::efl::eolian::to_c(icon_)));
}

inline bool eo_cxx::elm::menu_item::selected_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_menu_item_selected_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::menu_item::selected_set(bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_menu_item_selected_set(::efl::eolian::to_c(selected_)));
}

inline ::eo_cxx::elm::menu_item::operator ::elm::menu_item() const
{
   return *static_cast<::elm::menu_item const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::menu_item::operator ::elm::menu_item&()
{
   return *static_cast<::elm::menu_item*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::menu_item::operator ::elm::menu_item const&() const
{
   return *static_cast<::elm::menu_item const*>(static_cast<void const*>(this));
}

template <typename T>
::elm::widget_item elm_menu_item_prev_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->prev_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::elm::widget_item elm_menu_item_next_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->next_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Widget_Item * _tmp_ret{};
         return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
unsigned int elm_menu_item_index_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->index_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         unsigned int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_menu_item_subitems_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->subitems_clear();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::crange_list< ::elm::widget_item > elm_menu_item_subitems_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->subitems_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }
}

template <typename T>
bool elm_menu_item_is_separator_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->is_separator();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::evas::object elm_menu_item_object_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->object_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Evas_Object * _tmp_ret{};
         return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::string_view elm_menu_item_icon_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->icon_name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_menu_item_icon_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * icon_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_name_set(::efl::eolian::to_cxx<::efl::eina::string_view>(icon_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_menu_item_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->selected_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_menu_item_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool selected_)
{
   try
      {
         static_cast<T*>(self->this_)->selected_set(::efl::eolian::to_cxx<bool>(selected_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::menu_item >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget_item >::template type<T>
         , virtual operations< ::elm_interface_atspi_selection >::template type<T>
   {
      virtual ::elm::widget_item prev_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_prev_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::elm::widget_item next_get()
      {
         Elm_Widget_Item * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_next_get());
            return ::efl::eolian::to_cxx<::elm::widget_item>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual unsigned int index_get()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_index_get());
            return _tmp_ret;
      }

      virtual void subitems_clear()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_menu_item_subitems_clear());
      }

      virtual ::efl::eina::crange_list< ::elm::widget_item > subitems_get()
      {
         const Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_subitems_get());
            return ::efl::eolian::to_cxx<::efl::eina::crange_list< ::elm::widget_item >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

      virtual bool is_separator()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_is_separator());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::evas::object object_get()
      {
         Evas_Object * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_object_get());
            return ::efl::eolian::to_cxx<::evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::string_view icon_name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_icon_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_name_set(::efl::eina::string_view icon_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_menu_item_icon_name_set(::efl::eolian::to_c(icon_)));
      }

      virtual bool selected_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_menu_item_selected_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void selected_set(bool selected_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_menu_item_selected_set(::efl::eolian::to_c(selected_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::menu_item >
{
   static constexpr int value = 
#if defined(MENU_ITEM_PROTECTED) && defined(MENU_ITEM_BETA)
      11
#elif defined(MENU_ITEM_PROTECTED)
      11
#elif defined(MENU_ITEM_BETA)
      11
#else
      11
#endif
      + operation_description_class_size<::elm::widget_item >::value      + operation_description_class_size<::elm_interface_atspi_selection >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::menu_item>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_prev_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_prev_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_next_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_next_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_index_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_index_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_subitems_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_subitems_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_subitems_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_subitems_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_is_separator_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_is_separator);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_object_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_object_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_icon_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_icon_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_icon_name_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_icon_name_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_menu_item_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_menu_item_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget_item>(), &ops[operation_description_class_size< ::elm::menu_item >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_selection>(), &ops[operation_description_class_size< ::elm::menu_item >::value + operation_description_class_size<::elm::widget_item>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::menu_item>)
{
   return (ELM_MENU_ITEM_CLASS);
}

} } }

/// @endcond

